major updates

pull/7/head
Botspot 5 years ago
parent 637d24d884
commit d51045ef79

@ -15,7 +15,9 @@ wget --load-cookies /tmp/cookies.txt "https://docs.google.com/uc?export=download
rm -f /tmp/cookies.txt || echo "Warning: failed to remove cookies.txt."
unzip ~/freecad-precompiled.zip || error "Failed to extract archive!"
rm -rf freecad-build FreeCAD-0.18.4 || error "Failed to delete freecad-build and FreeCAD-0.18.4 folders!"
unzip -q ~/freecad-precompiled.zip || error "Failed to extract archive!"
rm -f ~/freecad-precompiled.zip || error "Failed to delete archive!"
cd freecad-build || error "Failed to enter directory!"

@ -19,7 +19,7 @@ wget https://github.com/FreeCAD/FreeCAD/archive/0.18.4.zip || error "failed to d
#ensure there's no directory in there already
rm -rf ~/FreeCAD-0.18.4 ~/freecad-build 2>/dev/null
unzip 0.18.4.zip || error "failed to extract ZIP file!"
unzip -q 0.18.4.zip || error "failed to extract ZIP file!"
rm 0.18.4.zip || error "failed to delete ZIP file!"

@ -0,0 +1,43 @@
Python-powered GUI for OMXPlayer with YouTube functionality.
To run: Menu -> Sound & Video -> TBOPlayer
To run in a terminal: python /opt/tboplayer/tboplayer.py
Buttons:
• ADD - duplicates the Track>Add menu item
• ADD DIR - duplicates the Track>Add Dir menu item
• EDIT - duplicates the Track>Edit menu item
• OPEN/SAVE/CLEAR LIST - duplicates the Playlist>Open,Save,Clear menu item
• PLAY/PAUSE - play the selected track or pause if playing
• STOP - stop playing, operational only during playing
• PREVIOUS - play previous track, operational only after played some track
• NEXT - play next track, up to mode that you set
• - VOL + - minus/plus volume control
• Playlist - can be clicked over to play a track, and can be used to add tracks by 'drag and dropping' files over
• Progress bar - show/Seek position
• Resize video - at the bottom right side of the video progress bar, allows resizing video
Menus:
• Track - add tracks (for selecting multiple tracks, hold ctrl when clicking) or directories, edit or remove tracks (or URLs) from the current playlist
• Playlist - save the current playlist or open a saved one or load youtube playlist
• OMX - display the track information for the last played track
• Options - see below:
Options:
• Audio Output - play sound to hdmi, local, both or ALSA device.
• Mode - play the Single selected track, Repeat the single track, rotate around the Playlist starting from the selected track, randomly play a track from the Playlist.
• Initial directory for tracks - where Add Track starts looking.
• Initial directory for playlists - where Open Playlist starts looking
• Enable subtitles - download and use subtitles from streamming services
• OMXPlayer location - path to omxplayer binary
• OMXplayer options - add your own (no validation so be careful)
• Download from Youtube - defines whether to download video and audio or audio only from Youtube (other online video services will always be asked for "video and audio")
• Download actual media URL [when] - defines when to extract the actual media from the given URL, either upon adding the URL or when playing it
• Youtube media quality - lets you choose among "small", "medium" and "high" qualities (Youtube only feature)
• youtube-dl location - path to youtube-dl binary
• Interface language - change GUI active language, requires restart
• Start/End track paused - pauses the track both in the beginning and in the end of the track
• Autoplay at start up - if TBOPlayer has just been opened and has some file in the playlist, automatically start playing the first file in the list
• Keep youtube-dl up-to-date - upon start, check if there is a newer version of youtube-dl, and if there is, install it
• Forbid windowed mode - if enabled will make videos always show in full screen, disabling the video window mode and video progress bar - may be useful if you're using tboplayer through a remote desktop
• Find lyrics - if enabled, TBOPlayer will try to fetch lyrics for playing track - defaults to off - more details below
• Debug - prints some debug text to the command line/log file (requires you to close and restart tboplayer)

Binary file not shown.

After

Width:  |  Height:  |  Size: 999 B

Binary file not shown.

After

Width:  |  Height:  |  Size: 2.3 KiB

@ -0,0 +1,13 @@
#!/bin/bash
function error {
echo -e "\e[31m$1\e[39m"
exit 1
}
# Get dependencies
DIRECTORY="$(dirname "$(dirname "$(dirname "$0")")")"
"${DIRECTORY}/pkg-install" "python-pip python-gobject-2 python-dbus python-tk python-gtk2 python-requests tkdnd" "$(dirname "$0")" || exit 1
cd ~ && wget https://github.com/KenT2/tboplayer/tarball/py2_version -O - | tar xz || error "Failed to download!"
cd KenT2-tboplayer-* && chmod +x setup.sh && ./setup.sh || error "failed to run setup.sh!"

@ -0,0 +1,12 @@
#!/bin/bash
function error {
echo -e "\e[31m$1\e[39m"
exit 1
}
DIRECTORY="$(dirname "$(dirname "$(dirname "$0")")")"
"${DIRECTORY}/purge-installed" "$(dirname "$0")" || exit 1
#run uninstall script, saying 'yes' to the first question, and 'no' to the second question
echo -e "y\nn" | /opt/tboplayer/setup.sh uninstall || error "failed to uninstall!"

@ -0,0 +1 @@
https://github.com/KenT2/tboplayer/tree/py2_version

@ -8,4 +8,3 @@ function error {
# Get dependencies
DIRECTORY="$(dirname "$(dirname "$(dirname "$0")")")"
#"${DIRECTORY}/pkg-install" "" "$(dirname "$0")" || exit 1
read enter

@ -0,0 +1 @@
uninstalled

23
gui

@ -11,15 +11,15 @@ while true;do
APPS="$(echo "$APPS" | tr '\n' '|')"
PREIFS="$IFS"
IFS=$"|"
IFS="|"
LIST=''
for i in $APPS
do
LIST="$LIST$(echo "${DIRECTORY}/icons/$(cat "${DIRECTORY}/data/apps/${i}" || echo "none").png")
LIST="$LIST$(echo "${DIRECTORY}/icons/$(cat "${DIRECTORY}/data/status/${i}" || echo "none").png")
${DIRECTORY}/apps/${i}/icon-24.png
$i
"\("$(cat "${DIRECTORY}/data/apps/${i}" || echo "Unknown state")"\)" $(echo "$(cat "${DIRECTORY}/apps/${i}/description" || echo "Description unavailable")" | head -n1)
"\("$(cat "${DIRECTORY}/data/status/${i}" || echo "Unknown state")"\)" $(echo "$(cat "${DIRECTORY}/apps/${i}/description" || echo "Description unavailable")" | head -n1)
"
done
IFS="$PREIFS"
@ -50,7 +50,20 @@ $i
0)
echo "Details"
info="$(if [ -f "${DIRECTORY}/data/status/${output}" ];then
echo -n "Current status: "
cat "${DIRECTORY}/data/status/${output}"
fi
if [ ! -z "$(cat "${DIRECTORY}/data/installed-packages/${output}")" ];then
echo -n "This app installed these packages: "
cat "${DIRECTORY}/data/installed-packages/${output}" | tr '\n' ' '
fi
)"
text="$(echo "$(cat "${DIRECTORY}/apps/${output}/description" || echo "Description unavailable")" | head -n1)
$info
Website: $(cat "${DIRECTORY}/apps/${output}/website" || echo "unavailable")
$(echo "$(cat "${DIRECTORY}/apps/${output}/description" || echo "Description unavailable")" | grep -v "$(echo "$(cat "${DIRECTORY}/apps/${output}/description" || echo "Description unavailable")" | head -n1)")"
echo "$text" | yad --text-info --fontname=12 --wrap --show-uri \
@ -63,11 +76,11 @@ $(echo "$(cat "${DIRECTORY}/apps/${output}/description" || echo "Description una
2)
echo "Uninstall"
"${DIRECTORY}/manage" "$output" uninstall
"${DIRECTORY}/manage" uninstall "$output"
;;
4)
echo "Install"
"${DIRECTORY}/manage" "$output" install
"${DIRECTORY}/manage" install "$output"
;;
esac
done

149
manage

@ -1,54 +1,67 @@
#!/bin/bash
#$1 is name of software, like Arduino
#$2 is install/uninstall
#$1 is an action, like install
#$2 is app name, like Arduino
DIRECTORY="$(readlink -f "$(dirname "$0")")"
function error {
echo -e "\e[31m$1\e[39m"
echo -e "\e[91m$1\e[39m"
exit 1
}
if [ -z "$1" ];then
error "You need to specify which app, and which action to apply to it. (install/uninstall)"
elif [ ! -d "${DIRECTORY}/apps/$1" ];then
error "${DIRECTORY}/apps/$1 does not exist!"
error "You need to specify an operation, and in most cases, which app to operate on."
fi
if [ "$2" == 'install' ];then
if [ "$1" == 'install' ];then
#for this operation, a program name must be specified.
if [ -z "$2" ];then
error "For this operation, you must specify which app to operate on."
elif [ ! -d "${DIRECTORY}/apps/$2" ];then
error "${DIRECTORY}/apps/$2 does not exist!"
fi
#INSTALL
#ensure an install script is not already running
if ps -C install ;then
echo "An install script is already running.
Pi-Apps will wait until that one finishes before starting this one." | yad --text-info \
Pi-Apps will wait until that one finishes before installing $2." | yad --text-info \
--title="Waiting" --window-icon="${DIRECTORY}/icons/logo.png" --center --width=500 --height=100 \
--button=OK!"${DIRECTORY}/icons/check.png":0 --fontname=12 --timeout=10 --timeout-indicator=top
while ps -C install ;do sleep 1; done
fi
#if already installed then ask for confirmation
if [ "$(cat "${DIRECTORY}/data/apps/${1}" )" == 'installed' ];then
yad --text="$1 is already installed. Are you sure you want to install it again?" \
if [ "$(cat "${DIRECTORY}/data/status/${2}" )" == 'installed' ];then
yad --text="$2 is already installed. Are you sure you want to install it again?" \
--text-align=center --center --title='Quick question' --window-icon="${DIRECTORY}/icons/logo.png" \
--button=No!"${DIRECTORY}/icons/exit.png":1 --button=Yes!"${DIRECTORY}/icons/check.png":0 || exit 0
fi
lxterminal --title="Installing $1" -e "
lxterminal --title="Installing $2" -e "
cd $HOME
echo 'corrupted' > \"${DIRECTORY}/data/apps/${1}\"
if \"${DIRECTORY}/apps/${1}/install\" ; then
echo 'installed' > \"${DIRECTORY}/data/apps/${1}\"
echo 'corrupted' > \"${DIRECTORY}/data/status/${2}\"
if \"${DIRECTORY}/apps/${2}/install\" ; then
echo 'installed' > \"${DIRECTORY}/data/status/${2}\"
echo -en '\n\e[42m\e[30mCommand succeeded.\e[39m\e[49m\nClose this window to exit.'
read enter #technically you could press Enter to exit.
else
echo 'corrupted' > \"${DIRECTORY}/data/apps/${1}\"
echo 'corrupted' > \"${DIRECTORY}/data/status/${2}\"
echo -en '\n\e[41m\e[30mCommand failed!\e[39m\e[49m\nClose this window to exit.'
read enter #technically you could press Enter to exit.
fi"
#wait until script is done before this command exits
sleep 2
while ps -C install >/dev/null;do sleep 1; done
elif [ "$2" == 'uninstall' ];then
elif [ "$1" == 'uninstall' ];then
#for this operation, a program name must be specified.
if [ -z "$2" ];then
error "For this operation, you must specify which app to operate on."
elif [ ! -d "${DIRECTORY}/apps/$2" ];then
error "${DIRECTORY}/apps/$2 does not exist!"
fi
#UNINSTALL
#ensure an uninstall script is not already running
if ps -C install ;then
echo "An uninstall script is already running.
@ -59,27 +72,115 @@ Pi-Apps will wait until that one finishes before starting this one." | yad --tex
fi
#if already uninstalled then ask for confirmation
if [ "$(cat "${DIRECTORY}/data/apps/${1}" )" == 'uninstalled' ];then
yad --text="$1 is already uninstalled. Are you sure you want to uninstall it again?" \
if [ "$(cat "${DIRECTORY}/data/status/${2}" )" == 'uninstalled' ];then
yad --text="$2 is already uninstalled. Are you sure you want to uninstall it again?" \
--text-align=center --center --title='Quick question' --window-icon="${DIRECTORY}/icons/logo.png" \
--button=No!"${DIRECTORY}/icons/exit.png":1 --button=Yes!"${DIRECTORY}/icons/check.png":0 || exit 0
fi
lxterminal --title="Uninstalling $1" -e "
lxterminal --title="Uninstalling $2" -e "
cd $HOME
echo 'corrupted' > \"${DIRECTORY}/data/apps/${1}\"
if \"${DIRECTORY}/apps/${1}/uninstall\" ; then
echo 'uninstalled' > \"${DIRECTORY}/data/apps/${1}\"
echo 'corrupted' > \"${DIRECTORY}/data/status/${2}\"
if \"${DIRECTORY}/apps/${2}/uninstall\" ; then
echo 'uninstalled' > \"${DIRECTORY}/data/status/${2}\"
echo -en '\n\e[42m\e[30mCommand succeeded.\e[39m\e[49m\nClose this window to exit.'
read enter #technically you could press Enter to exit.
else
echo 'corrupted' > \"${DIRECTORY}/data/apps/${1}\"
echo 'corrupted' > \"${DIRECTORY}/data/status/${2}\"
echo -en '\n\e[41m\e[30mCommand failed!\e[39m\e[49m\nClose this window to exit.'
read enter #technically you could press Enter to exit.
fi"
#wait until script is done before this command exits
sleep 2
while ps -C uninstall >/dev/null;do sleep 1; done
elif [ "$1" == 'update' ];then
#for this operation, a program name must be specified.
if [ -z "$2" ];then
error "For this operation, you must specify which app to operate on."
fi
#UPDATE
rm -rf "${DIRECTORY}/update" && mkdir "${DIRECTORY}/update" && cd "${DIRECTORY}/update" || error "failed to enter the update directory!"
git clone https://github.com/Botspot/pi-apps || error "failed to clone repository!"
newhash=$(find "${DIRECTORY}/update/pi-apps/apps/${2}" -type f -print0 | xargs -0 sha1sum | awk '{print $1}' | sha1sum | awk '{print $1}')
oldhash=$(find "${DIRECTORY}/apps/${2}" -type f -print0 | xargs -0 sha1sum | awk '{print $1}' | sha1sum | awk '{print $1}')
echo -e "newhash: $newhash\noldhash: $oldhash"
if [ "$newhash" == "$oldhash" ];then
echo "$2 is identical to the online version. Nothing to do!"
exit 0
else
echo "$2 is not identical to the online version. Reinstalling..."
fi
#else
#if installed already
if [ "$(cat "${DIRECTORY}/data/status/${2}")" == 'installed' ];then
installback=yes
#uninstall it using a recursive script instance
"${DIRECTORY}/manage" uninstall "$2"
else
installback=no
fi
#move old program to trash
gio trash "${DIRECTORY}/apps/${2}"
#copy new version to apps/
cp -rf "${DIRECTORY}/update/pi-apps/apps/${2}" "${DIRECTORY}/apps/${2}"
if [ "$installback" == 'yes' ];then
echo "$2 was originally installed before updating. Reinstalling the new version now."
#install it using a recursive script instance
"${DIRECTORY}/manage" install "$2"
fi
elif [ "$1" == 'check-all' ];then
#for this operation, a program name cannot be specified.
#CHECK-ALL
rm -rf "${DIRECTORY}/update" && mkdir "${DIRECTORY}/update" && cd "${DIRECTORY}/update" || error "failed to enter the update directory!"
git clone https://github.com/Botspot/pi-apps || error "failed to clone repository!"
updatable=''
echo "app list: $(echo "$(ls "${DIRECTORY}/update/pi-apps/apps")" | grep -v 'template')"
PREIFS="$IFS"
IFS="|"
newapps="$(echo "$(ls "${DIRECTORY}/update/pi-apps/apps")" | grep -v 'template' | tr '\n' '|')"
for newapp in $newapps
do
echo "newapp: $newapp"
newhash=$(find "${DIRECTORY}/update/pi-apps/apps/${newapp}" -type f -print0 | xargs -0 sha1sum | awk '{print $1}' | sha1sum | awk '{print $1}')
oldhash=$(find "${DIRECTORY}/apps/${newapp}" -type f -print0 | xargs -0 sha1sum | awk '{print $1}' | sha1sum | awk '{print $1}')
echo -e "newhash: $newhash\noldhash: $oldhash"
if [ "$newhash" == "$oldhash" ];then
echo "${newapp} is identical to the online version. Nothing to do!"
else
echo "${newapp} is not identical to the online version. Adding to updatable list..."
updatable="${updatable}|${newapp}"
fi
done
#remove initial '|' character
updatable="${updatable:1}"
IFS="$PREIFS"
echo -e "These apps can be updated:\n${updatable}"
elif [ "$1" == 'update-all' ];then
#for this operation, a program name cannot be specified.
PREIFS="$IFS"
IFS='|'
updatable="$("${DIRECTORY}/manage" check-all | tail -1)"
echo "Updatable: ${updatable}EOU"
for updateapp in $updatable
do
echo "updating $updateapp"
#update it using a recursive script instance
echo "${DIRECTORY}/manage update $updateapp"
"${DIRECTORY}/manage" update "$updateapp"
done
IFS="$PREIFS"
else
error "Did not understand $2. It must be either "\'"install"\'" or "\'"uninstall"\'"."
error "Did not understand ${1}. It must be either "\'"install"\'", "\'"uninstall"\'", "\'"update"\'", or "\'"check-all"\'"."
fi

@ -0,0 +1,8 @@
[Desktop Entry]
Name=Pi-Apps
Comment=Simple RPI App Store for projects not in the repositories
Exec=/home/pi/pi-apps/gui
Icon=/home/pi/pi-apps/icons/logo.png
Terminal=false
Type=Application
Categories=Utility;

@ -1,39 +1,42 @@
#!/bin/bash
#$1 is a quotation-marked, space-seperated list of package names.
#$2 is the path to the program folder being installed. For example, /home/pi/pi-apps/apps/Arduino
#$2 is the path to the program folder being installed.
#Example usage: ~/pi-apps/pkg-install "gparted buffer expect" ~/pi-apps/apps/Arduino
PKG_LIST="$1"
PRG_DIR="$2"
PRG="$(echo "$2" | tr '/' '\n' | tail -1)"
DIRECTORY="$(readlink -f "$(dirname "$0")")"
function error {
echo -e "\e[91m$1\e[39m"
exit 1
}
echo "Running pkg-install..."
if [ -z "$PKG_LIST" ];then
echo -e "\e[91mNo packages were specified!\e[39m"
exit=1
exit=yes
fi
if [ -z "$PRG_DIR" ];then
if [ -z "$PRG" ];then
echo -e "\e[91mNo program directory specified!\e[39m"
exit=1
elif [ ! -d "$PRG_DIR" ];then
echo -e "\e[91m$PRG_DIR does not exist!\e[39m"
exit=1
elif [ -z "$(echo "$PRG_DIR" | grep "pi-apps/apps")" ];then
echo -e "\e[33mWarning: That program directory ($PRG_DIR) is located outside of pi-apps.\e[39m"
exitcode=1
elif [ ! -d "$2" ];then
echo -e "\e[91m$2 does not exist!\e[39m"
exitcode=1
elif [ -z "$(echo "$2" | grep "pi-apps/apps")" ];then
echo -e "\e[33mWarning: That program directory ($PRG) is located outside of pi-apps.\e[39m"
fi
if [ ! -z $exit ];then
if [ ! -z $exitcode ];then
echo -e '$1 is a quotation-marked, space-seperated list of package names.\n$2 is the path to the program folder being installed.\nExample usage: ~/pi-apps/pkg-install '\"'gparted buffer expect'\"' ~/pi-apps/apps/Arduino'
echo -e "\e[91mExiting now.\e[39m"
exit 1
fi
if [ "$PRG_DIR" == "*/" ]; then # ensure there is no trailing slash
PRG_DIR=${PRG_DIR: :-1}
fi
echo "Running pkg-install..."
output="$(sudo apt update 2>&1)"
exitcode=$?
@ -59,7 +62,7 @@ do
done
#save that list of installed packages in the program directory for future removal
echo $INSTALL_LIST >> "$PRG_DIR/installed-packages"
echo "$INSTALL_LIST" >> "${DIRECTORY}/data/installed-packages/${PRG}"
if [ ! -z "$INSTALL_LIST" ];then
echo -e "These packages will be installed: \e[2m$INSTALL_LIST\e[22m"
@ -75,7 +78,7 @@ if [ ! -z "$INSTALL_LIST" ];then
INSTALL_LIST=''
for i in $PKG_LIST
do
PKG_OK="$(dpkg-query -W --showformat='${Status}\n' "$i" 2>/dev/null |grep "install ok installed")"
PKG_OK="$(dpkg-query -W --showformat='${Status}\n' "$i" 2>/dev/null | grep "install ok installed")"
if [ "" == "$PKG_OK" ]; then
INSTALL_LIST="${INSTALL_LIST} ${i}" #add package to install list
fi

@ -3,36 +3,38 @@
#$1 is the path to the program folder being installed. For example, /home/pi/pi-apps/apps/Arduino
#Example usage: ~/pi-apps/uninstall-installed ~/pi-apps/apps/Arduino
PRG_DIR="$1"
PRG="$(echo "$1" | tr '/' '\n' | tail -1)"
if [ -z "$PRG_DIR" ];then
DIRECTORY="$(readlink -f "$(dirname "$0")")"
if [ -z "$PRG" ];then
echo -e "\e[91mNo program directory specified!\e[39m"
exitcode=1
elif [ ! -d "$PRG_DIR" ];then
echo -e "\e[91m$PRG_DIR does not exist!\e[39m"
elif [ ! -d "$1" ];then
echo -e "\e[91m$1 does not exist!\e[39m"
exitcode=1
elif [ -z "$(echo "$PRG_DIR" | grep "pi-apps/apps")" ];then
echo -e "\e[33mWarning: That program directory ($PRG_DIR) is located outside of pi-apps.\e[39m"
elif [ -z "$(echo "$1" | grep "pi-apps/apps")" ];then
echo -e "\e[33mWarning: That program directory ($1) is located outside of pi-apps.\e[39m"
fi
if [ ! -z $exitcode ];then
echo -e "\e[91mExiting now.\e[39m"
exit $exit
exit 1
fi
function error {
echo -e "\e[31m$1\e[39m"
echo -e "\e[91m$1\e[39m"
exit 1
}
echo "Running purge-installed..."
PKG_LIST="$(cat "$PRG_DIR/installed-packages")"
PKG_LIST="$(cat "${DIRECTORY}/data/installed-packages/${PRG}")"
if [ ! -f "$PRG_DIR/installed-packages" ];then
echo -e "\e[33mDoes $PRG_DIR/installed-packages exist?\e[39m"
if [ ! -f "${DIRECTORY}/data/installed-packages/${PRG}" ];then
echo -e "\e[33mDoes ${DIRECTORY}/data/installed-packages/${PRG} exist?\e[39m"
exit 0
fi
if [ -z "$PRG_DIR/installed-packages" ];then
if [ -z "${DIRECTORY}/data/installed-packages/${PRG}" ];then
echo "Nothing to purge. Exiting now."
exit 0
fi
@ -71,5 +73,5 @@ if [ ! -z "$INSTALL_LIST" ];then
error "\e[91mAPT did not exit with an error, but these packages are still installed somehow: $INSTALL_LIST\e[39m"
else
echo -e "\e[32mAll packages were purged succesfully.\e[39m"
rm "$PRG_DIR/installed-packages"
gio trash "${DIRECTORY}/data/installed-packages/${PRG}"
fi

@ -0,0 +1 @@
Subproject commit 637d24d884a25d46012a5b5ab6fb876686fe6bdf
Loading…
Cancel
Save